---
title: Product Usage Research Survey
product: PDF Generator
description: Get a printable product usage research survey in PDF. Create editable or prefilled product research questionnaires with SurveyJS PDF Generator.
framework: Vanilla JS
source: https://surveyjs.io/pdf-generator/examples/template-product-usage-research-survey-template/vanillajs
index: https://surveyjs.io/pdf-generator/examples/overview.md
---

# Product Usage Research Survey (Vanilla JS)

## Files

### `public/index.html`

```html
<div style="display: flex;">
    <div id="surveyElement" style="flex: 1 1 0%; height: 100%; min-width: 0;"></div>
    <div id="pdf-preview" style="flex: 0.7 0.7 0%; display: none">
        <embed id="pdf-preview-frame" type="application/pdf" style="width:100%; height:100%;" />
    </div>
</div>
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import { Model } from "survey-core";
import "survey-js-ui";
import { SurveyPDF } from "survey-pdf";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";

function createSurveyPdfModel (surveyModel) {
    const surveyPDF = new SurveyPDF(json);
    if (surveyModel) {
        surveyPDF.data = surveyModel.data;
        surveyPDF.locale = surveyModel.locale;
        
        
    }
    
    return surveyPDF;
}
function saveSurveyToPdf (filename, surveyModel) {
    const pdfDoc = createSurveyPdfModel(surveyModel);
    if (!pdfDoc) return;

    pdfDoc.save(filename);
}

const previewDiv = document.getElementById("pdf-preview");
const previewEmbed = document.getElementById("pdf-preview-frame");
let pdfBlobUrl;

function showPdfPreview(surveyModel) {
    if (!previewDiv || !previewEmbed) return;

    const pdfDoc = createSurveyPdfModel(surveyModel);
    if (!pdfDoc) return;

    pdfDoc.raw("blob").then((blob) => {
        if (pdfBlobUrl) {
            URL.revokeObjectURL(pdfBlobUrl);
        }
        pdfBlobUrl = URL.createObjectURL(blob);
        previewEmbed.setAttribute("src", pdfBlobUrl);
        previewDiv.style.display = "block";
    });
}

function previewPdf(surveyModel) {
    if (!previewDiv) return;

    if (previewDiv.style.display !== "none") {
        previewDiv.style.display = "none";
        return;
    }

    showPdfPreview(surveyModel);
}

const survey = new Model(json);
survey.showCompleteButton = false;
survey.navigationButtonsLocation = "topBottom";
survey.addNavigationItem({
    id: "survey_save_as_file",
    title: "Download PDF",
    action: () => {
        saveSurveyToPdf("surveyResult.pdf", survey);
    }
});
survey.addNavigationItem({
    id: "survey_pdf_preview",
    title: "Preview PDF",
    visible: window.navigator.pdfViewerEnabled,
    action: () => {
        previewPdf(survey);
    }
});
survey.render(document.getElementById("surveyElement"));
```

### `src/json.js`

```js
export const json = {
  "title": "Product Usage Research Survey",
  "questionsOnPageMode": "singlePage",
  "headerView": "advanced",
  "pages": [
    {
      "name": "participant-information",
      "title": "Section 1: Demographic Information",
      "elements": [
        {
          "type": "text",
          "name": "name",
          "title": "Full Name",
          "isRequired": true,
          "minWidth": "auto"
        },
        {
          "type": "text",
          "name": "dob",
          "startWithNewLine": false,
          "title": "Date of Birth",
          "inputType": "date",
          "minWidth": "auto"
        },
        {
          "type": "radiogroup",
          "name": "gender",
          "title": "Gender",
          "choices": [
            "Male",
            "Female",
            "Other"
          ],
          "startWithNewLine": false,
          "minWidth": "auto",
          "colCount": 2
        },
        {
          "type": "text",
          "name": "occupation",
          "title": "Current Occupation"
        },
        {
          "type": "text",
          "name": "location",
          "title": "City and Country of Residence",
          "startWithNewLine": false
        },
        {
          "type": "text",
          "name": "email",
          "title": "Email Address (optional)",
          "inputType": "email"
        },
        {
          "type": "text",
          "name": "phone-number",
          "startWithNewLine": false,
          "title": "Phone Number (optional)",
          "maskType": "pattern",
          "maskSettings": {
            "pattern": "+1(999)-999-99-99"
          }
        },
        {
          "type": "radiogroup",
          "name": "income",
          "title": "Approximate Household Income",
          "choices": [
            "Below $25,000",
            "$25,000 - $50,000",
            "$50,000 - $75,000",
            "$75,000 - $100,000",
            "Above $100,000"
          ],
          "colCount": 2
        },
        {
          "type": "radiogroup",
          "name": "education-level",
          "title": "Highest Level of Education Completed",
          "choices": [
            "High School",
            "Some College",
            "Bachelor Degree",
            "Master Degree",
            "Doctorate"
          ],
          "showOtherItem": true,
          "otherText": "Other",
          "colCount": 2
        },
        {
          "type": "radiogroup",
          "name": "marital-status",
          "title": "Marital Status",
          "choices": [
            "Single",
            "Married",
            "Divorced",
            "Widowed"
          ],
          "colCount": 2
        }
      ]
    },
    {
      "name": "product-information",
      "title": "Section 2: Purchase and Usage Details",
      "elements": [
        {
          "type": "checkbox",
          "name": "models",
          "title": "Select all sneaker models you have used",
          "isRequired": true,
          "choices": [
            "Nike Air Max Plus OG Voltage Purple",
            "Nike Dunk Low Brazil",
            "New Balance 1906R Lava",
            "Nike Air Max 95 Black",
            "Nike Air Max Dn Black",
            "Jordan Jumpman Jack Sail",
            "Air Jordan 1 Low OG Away"
          ],
          "showNoneItem": true,
          "colCount": 2
        },
        {
          "type": "paneldynamic",
          "name": "purchase-details",
          "title": "Provide details for each selected model",
          "panelCount": 3,
          "panelsState": "firstExpanded",
          "templateTitle": "Model {panelIndex}",
          "templateElements": [
            {
              "type": "text",
              "title": "Model Name"
            },
            {
              "name": "purchase-date",
              "title": "Date of Purchase",
              "type": "text",
              "inputType": "date",
              "startWithNewLine": false
            },
            {
              "name": "frequency",
              "title": "How often do you use this model?",
              "type": "radiogroup",
              "choices": [
                "Daily",
                "Several times a week",
                "Once a week",
                "Several times a month",
                "Once a month or less"
              ],
              "colCount": 2
            },
            {
              "name": "primary-activity",
              "title": "What is the primary use of this model?",
              "type": "radiogroup",
              "choices": [
                "Casual Wear",
                "Sports or Exercise",
                "Work or School",
                "Special Occasions",
                "Collecting"
              ],
              "colCount": 2,
              "startWithNewLine": false
            },
            {
              "type": "radiogroup",
              "name": "first-hear",
              "title": "How did you first learn about this model?",
              "choices": [
                "Social Media",
                "Friend or Family",
                "Online Advertisement",
                "In Store Display",
                "Review Website"
              ],
              "showOtherItem": true,
              "otherText": "Other"
            },
            {
              "type": "radiogroup",
              "name": "where-purchased",
              "startWithNewLine": false,
              "title": "Where did you purchase this model?",
              "choices": [
                "Online Retailer",
                "Official Website",
                "Physical Store",
                "Reseller"
              ],
              "showOtherItem": true,
              "otherText": "Other"
            },
            {
              "type": "boolean",
              "name": "remember-name",
              "title": "Do you remember the name of the store or seller?"
            },
            {
              "type": "text",
              "name": "specify-name",
              "startWithNewLine": false,
              "title": "If yes, enter the name of the store or seller"
            },
            {
              "type": "matrixdropdown",
              "name": "rating-matrix",
              "title": "Please rate the following aspects",
              "showHeader": false,
              "columns": [
                {
                  "name": "rating-scale",
                  "cellType": "rating",
                  "minRateDescription": "Very dissatisfied",
                  "maxRateDescription": "Very satisfied"
                }
              ],
              "rows": [
                {
                  "value": "comfort",
                  "text": "Comfort"
                },
                {
                  "value": "durability",
                  "text": "Durability"
                },
                {
                  "value": "design",
                  "text": "Design and Style"
                }
              ],
              "rowTitleWidth": "25%"
            }
          ]
        }
      ]
    },
    {
      "name": "usage-patterns",
      "title": "Section 3: Features and Preferences",
      "elements": [
        {
          "type": "paneldynamic",
          "name": "most-least-panel",
          "title": "Evaluate features for each selected model",
          "panelCount": 3,
          "panelsState": "firstExpanded",
          "templateTitle": "Model {panelIndex}",
          "templateElements": [
            {
              "type": "text",
              "title": "Model Name"
            },
            {
              "type": "ranking",
              "name": "like-most",
              "title": "Select and rank the features you like most",
              "choices": [
                "Comfort",
                "Style",
                "Brand Reputation",
                "Durability",
                "Limited Edition",
                "Versatility"
              ],
              "minSelectedChoices": 2,
              "selectToRankEnabled": true
            },
            {
              "type": "ranking",
              "name": "like-least",
              "title": "Select and rank the features you like least",
              "choices": [
                "Comfort",
                "Style",
                "Brand Reputation",
                "Durability",
                "Limited Edition",
                "Versatility"
              ],
              "minSelectedChoices": 2,
              "selectToRankEnabled": true
            },
            {
              "type": "boolean",
              "name": "issues",
              "title": "Have you experienced any issues with this model?",
              "showCommentArea": true,
              "commentText": "If yes, please describe the issue"
            },
            {
              "type": "radiogroup",
              "name": "recommend",
              "title": "Would you recommend this model to others?",
              "choices": [
                "Yes",
                "No",
                "Maybe"
              ],
              "colCount": 3
            },
            {
              "type": "radiogroup",
              "name": "purchase-same-brand",
              "title": "How likely are you to purchase from this brand again?",
              "choices": [
                "Very unlikely",
                "Unlikely",
                "Neutral",
                "Likely",
                "Very likely"
              ],
              "colCount": 2
            }
          ]
        }
      ]
    },
    {
      "name": "additional-feedback-section",
      "title": "Section 4: Additional Feedback",
      "elements": [
        {
          "type": "paneldynamic",
          "name": "additional-question",
          "title": "Additional Feedback (if applicable)",
          "panelCount": 3,
          "panelsState": "firstExpanded",
          "templateTitle": "Model {panelIndex}",
          "templateElements": [
            {
              "type": "boolean",
              "name": "support",
              "title": "Have you contacted customer support regarding this model?"
            },
            {
              "type": "rating",
              "name": "support-experience",
              "title": "If yes, how would you rate your experience?",
              "rateCount": 10,
              "rateMax": 10,
              "minRateDescription": "Very poor",
              "maxRateDescription": "Excellent"
            },
            {
              "type": "comment",
              "name": "improvements",
              "title": "What improvements would you suggest for this model?"
            },
            {
              "type": "comment",
              "name": "additional-comments",
              "title": "Please share any additional comments or feedback"
            }
          ]
        }
      ]
    }
  ]
};
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "survey-core": "latest",
    "survey-js-ui": "latest",
    "survey-pdf": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/pdf-generator/examples/template-product-usage-research-survey-template/angular.md)
- [React](https://surveyjs.io/pdf-generator/examples/template-product-usage-research-survey-template/reactjs.md)
- [Vue 3](https://surveyjs.io/pdf-generator/examples/template-product-usage-research-survey-template/vue3js.md)
- [jQuery](https://surveyjs.io/pdf-generator/examples/template-product-usage-research-survey-template/jquery.md)


---
title: Product Usage Research Survey
product: PDF Generator
description: Get a printable product usage research survey in PDF. Create editable or prefilled product research questionnaires with SurveyJS PDF Generator.
framework: Angular
source: https://surveyjs.io/pdf-generator/examples/template-product-usage-research-survey-template/angular
index: https://surveyjs.io/pdf-generator/examples/overview.md
---

# Product Usage Research Survey (Angular)

## Files

### `src/app/components/json.ts`

```ts
export const json = {
  "title": "Product Usage Research Survey",
  "questionsOnPageMode": "singlePage",
  "headerView": "advanced",
  "pages": [
    {
      "name": "participant-information",
      "title": "Section 1: Demographic Information",
      "elements": [
        {
          "type": "text",
          "name": "name",
          "title": "Full Name",
          "isRequired": true,
          "minWidth": "auto"
        },
        {
          "type": "text",
          "name": "dob",
          "startWithNewLine": false,
          "title": "Date of Birth",
          "inputType": "date",
          "minWidth": "auto"
        },
        {
          "type": "radiogroup",
          "name": "gender",
          "title": "Gender",
          "choices": [
            "Male",
            "Female",
            "Other"
          ],
          "startWithNewLine": false,
          "minWidth": "auto",
          "colCount": 2
        },
        {
          "type": "text",
          "name": "occupation",
          "title": "Current Occupation"
        },
        {
          "type": "text",
          "name": "location",
          "title": "City and Country of Residence",
          "startWithNewLine": false
        },
        {
          "type": "text",
          "name": "email",
          "title": "Email Address (optional)",
          "inputType": "email"
        },
        {
          "type": "text",
          "name": "phone-number",
          "startWithNewLine": false,
          "title": "Phone Number (optional)",
          "maskType": "pattern",
          "maskSettings": {
            "pattern": "+1(999)-999-99-99"
          }
        },
        {
          "type": "radiogroup",
          "name": "income",
          "title": "Approximate Household Income",
          "choices": [
            "Below $25,000",
            "$25,000 - $50,000",
            "$50,000 - $75,000",
            "$75,000 - $100,000",
            "Above $100,000"
          ],
          "colCount": 2
        },
        {
          "type": "radiogroup",
          "name": "education-level",
          "title": "Highest Level of Education Completed",
          "choices": [
            "High School",
            "Some College",
            "Bachelor Degree",
            "Master Degree",
            "Doctorate"
          ],
          "showOtherItem": true,
          "otherText": "Other",
          "colCount": 2
        },
        {
          "type": "radiogroup",
          "name": "marital-status",
          "title": "Marital Status",
          "choices": [
            "Single",
            "Married",
            "Divorced",
            "Widowed"
          ],
          "colCount": 2
        }
      ]
    },
    {
      "name": "product-information",
      "title": "Section 2: Purchase and Usage Details",
      "elements": [
        {
          "type": "checkbox",
          "name": "models",
          "title": "Select all sneaker models you have used",
          "isRequired": true,
          "choices": [
            "Nike Air Max Plus OG Voltage Purple",
            "Nike Dunk Low Brazil",
            "New Balance 1906R Lava",
            "Nike Air Max 95 Black",
            "Nike Air Max Dn Black",
            "Jordan Jumpman Jack Sail",
            "Air Jordan 1 Low OG Away"
          ],
          "showNoneItem": true,
          "colCount": 2
        },
        {
          "type": "paneldynamic",
          "name": "purchase-details",
          "title": "Provide details for each selected model",
          "panelCount": 3,
          "panelsState": "firstExpanded",
          "templateTitle": "Model {panelIndex}",
          "templateElements": [
            {
              "type": "text",
              "title": "Model Name"
            },
            {
              "name": "purchase-date",
              "title": "Date of Purchase",
              "type": "text",
              "inputType": "date",
              "startWithNewLine": false
            },
            {
              "name": "frequency",
              "title": "How often do you use this model?",
              "type": "radiogroup",
              "choices": [
                "Daily",
                "Several times a week",
                "Once a week",
                "Several times a month",
                "Once a month or less"
              ],
              "colCount": 2
            },
            {
              "name": "primary-activity",
              "title": "What is the primary use of this model?",
              "type": "radiogroup",
              "choices": [
                "Casual Wear",
                "Sports or Exercise",
                "Work or School",
                "Special Occasions",
                "Collecting"
              ],
              "colCount": 2,
              "startWithNewLine": false
            },
            {
              "type": "radiogroup",
              "name": "first-hear",
              "title": "How did you first learn about this model?",
              "choices": [
                "Social Media",
                "Friend or Family",
                "Online Advertisement",
                "In Store Display",
                "Review Website"
              ],
              "showOtherItem": true,
              "otherText": "Other"
            },
            {
              "type": "radiogroup",
              "name": "where-purchased",
              "startWithNewLine": false,
              "title": "Where did you purchase this model?",
              "choices": [
                "Online Retailer",
                "Official Website",
                "Physical Store",
                "Reseller"
              ],
              "showOtherItem": true,
              "otherText": "Other"
            },
            {
              "type": "boolean",
              "name": "remember-name",
              "title": "Do you remember the name of the store or seller?"
            },
            {
              "type": "text",
              "name": "specify-name",
              "startWithNewLine": false,
              "title": "If yes, enter the name of the store or seller"
            },
            {
              "type": "matrixdropdown",
              "name": "rating-matrix",
              "title": "Please rate the following aspects",
              "showHeader": false,
              "columns": [
                {
                  "name": "rating-scale",
                  "cellType": "rating",
                  "minRateDescription": "Very dissatisfied",
                  "maxRateDescription": "Very satisfied"
                }
              ],
              "rows": [
                {
                  "value": "comfort",
                  "text": "Comfort"
                },
                {
                  "value": "durability",
                  "text": "Durability"
                },
                {
                  "value": "design",
                  "text": "Design and Style"
                }
              ],
              "rowTitleWidth": "25%"
            }
          ]
        }
      ]
    },
    {
      "name": "usage-patterns",
      "title": "Section 3: Features and Preferences",
      "elements": [
        {
          "type": "paneldynamic",
          "name": "most-least-panel",
          "title": "Evaluate features for each selected model",
          "panelCount": 3,
          "panelsState": "firstExpanded",
          "templateTitle": "Model {panelIndex}",
          "templateElements": [
            {
              "type": "text",
              "title": "Model Name"
            },
            {
              "type": "ranking",
              "name": "like-most",
              "title": "Select and rank the features you like most",
              "choices": [
                "Comfort",
                "Style",
                "Brand Reputation",
                "Durability",
                "Limited Edition",
                "Versatility"
              ],
              "minSelectedChoices": 2,
              "selectToRankEnabled": true
            },
            {
              "type": "ranking",
              "name": "like-least",
              "title": "Select and rank the features you like least",
              "choices": [
                "Comfort",
                "Style",
                "Brand Reputation",
                "Durability",
                "Limited Edition",
                "Versatility"
              ],
              "minSelectedChoices": 2,
              "selectToRankEnabled": true
            },
            {
              "type": "boolean",
              "name": "issues",
              "title": "Have you experienced any issues with this model?",
              "showCommentArea": true,
              "commentText": "If yes, please describe the issue"
            },
            {
              "type": "radiogroup",
              "name": "recommend",
              "title": "Would you recommend this model to others?",
              "choices": [
                "Yes",
                "No",
                "Maybe"
              ],
              "colCount": 3
            },
            {
              "type": "radiogroup",
              "name": "purchase-same-brand",
              "title": "How likely are you to purchase from this brand again?",
              "choices": [
                "Very unlikely",
                "Unlikely",
                "Neutral",
                "Likely",
                "Very likely"
              ],
              "colCount": 2
            }
          ]
        }
      ]
    },
    {
      "name": "additional-feedback-section",
      "title": "Section 4: Additional Feedback",
      "elements": [
        {
          "type": "paneldynamic",
          "name": "additional-question",
          "title": "Additional Feedback (if applicable)",
          "panelCount": 3,
          "panelsState": "firstExpanded",
          "templateTitle": "Model {panelIndex}",
          "templateElements": [
            {
              "type": "boolean",
              "name": "support",
              "title": "Have you contacted customer support regarding this model?"
            },
            {
              "type": "rating",
              "name": "support-experience",
              "title": "If yes, how would you rate your experience?",
              "rateCount": 10,
              "rateMax": 10,
              "minRateDescription": "Very poor",
              "maxRateDescription": "Excellent"
            },
            {
              "type": "comment",
              "name": "improvements",
              "title": "What improvements would you suggest for this model?"
            },
            {
              "type": "comment",
              "name": "additional-comments",
              "title": "Please share any additional comments or feedback"
            }
          ]
        }
      ]
    }
  ]
};
```

### `src/app/components/pdf.component.css`

```css
/* You can add your custom CSS here. */
```

### `src/app/components/pdf.component.html`

```html
<survey [model]="model"></survey>
```

### `src/app/components/pdf.component.ts`

```ts
import { Component, OnInit } from "@angular/core";
import { Model } from "survey-core";
import { SurveyPDF } from "survey-pdf";
import { json } from "./json";
import "./pdf.component.css";
import "survey-core/survey-core.min.css";

function createSurveyPdfModel (surveyModel) {
    const surveyPDF = new SurveyPDF(json);
    if (surveyModel) {
        surveyPDF.data = surveyModel.data;
        surveyPDF.locale = surveyModel.locale;
        
        
    }
    
    return surveyPDF;
}
function saveSurveyToPdf (filename, surveyModel) {
    const pdfDoc = createSurveyPdfModel(surveyModel);
    if (!pdfDoc) return;

    pdfDoc.save(filename);
}

const previewDiv = document.getElementById("pdf-preview");
const previewEmbed = document.getElementById("pdf-preview-frame");
let pdfBlobUrl;

function showPdfPreview(surveyModel) {
    if (!previewDiv || !previewEmbed) return;

    const pdfDoc = createSurveyPdfModel(surveyModel);
    if (!pdfDoc) return;

    pdfDoc.raw("blob").then((blob) => {
        if (pdfBlobUrl) {
            URL.revokeObjectURL(pdfBlobUrl);
        }
        pdfBlobUrl = URL.createObjectURL(blob);
        previewEmbed.setAttribute("src", pdfBlobUrl);
        previewDiv.style.display = "block";
    });
}

function previewPdf(surveyModel) {
    if (!previewDiv) return;

    if (previewDiv.style.display !== "none") {
        previewDiv.style.display = "none";
        return;
    }

    showPdfPreview(surveyModel);
}

@Component({
    // tslint:disable-next-line:component-selector
    selector: "component-survey",
    templateUrl: "./pdf.component.html",
    styleUrls: ["./pdf.component.css"]
})
export class SurveyPdfComponent implements OnInit {
    model: Model;
    ngOnInit() {
        const survey = new Model(json);
        survey.showCompleteButton = false;
        survey.navigationButtonsLocation = "topBottom";
        survey.addNavigationItem({
            id: "survey_save_as_file",
            title: "Download PDF",
            action: () => {
                saveSurveyToPdf("surveyResult.pdf", survey);
            }
        });
        survey.addNavigationItem({
            id: "survey_pdf_preview",
            title: "Preview PDF",
            visible: window.navigator.pdfViewerEnabled,
            action: () => {
                previewPdf(survey);
            }
        });
        this.model = survey;
    }
}
```

### `src/app/components/theme.ts`

```ts
export const themeJson = {};
```

### `src/app/app.component.css`

```css

```

### `src/app/app.component.html`

```html
<component-survey></component-survey>
```

### `src/app/app.component.ts`

```ts
import { Component } from "@angular/core";

@Component({
    selector: "app-root",
    templateUrl: "./app.component.html",
    styleUrls: ["./app.component.css"]
})
export class AppComponent {
    title = "CodeSandbox";
}
```

### `src/app/app.module.ts`

```ts
import { BrowserModule } from "@angular/platform-browser";
import { NgModule } from "@angular/core";

import { AppComponent } from "./app.component";
import { SurveyModule } from "survey-angular-ui";
import { SurveyPdfComponent } from "./components/pdf.component";

@NgModule({
    declarations: [AppComponent, SurveyPdfComponent],
    imports: [BrowserModule, SurveyModule],
    providers: [],
    bootstrap: [AppComponent]
})
export class AppModule { }
```

### `src/environments/environment.prod.ts`

```ts
export const environment = {
    production: true
};
```

### `src/environments/environment.ts`

```ts
// The file contents for the current environment will overwrite these during build.
// The build system defaults to the dev environment which uses `environment.ts`, but if you do
// `ng build --env=prod` then `environment.prod.ts` will be used instead.
// The list of which env maps to which file can be found in `.angular-cli.json`.

export const environment = {
    production: false
};
```

### `src/index.html`

```html
<div style="display: flex;">
    <div id="surveyElement" style="flex: 1 1 0%; height: 100%; min-width: 0;">
        <app-root></app-root>
    </div>
    <div id="pdf-preview" style="flex: 0.7 0.7 0%; display: none">
        <embed id="pdf-preview-frame" type="application/pdf" style="width:100%; height:100%;" />
    </div>
</div>
```

### `src/main.ts`

```ts
import { enableProdMode } from "@angular/core";
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";

import { AppModule } from "./app/app.module";
import { environment } from "./environments/environment";

if (environment.production) {
    enableProdMode();
}

platformBrowserDynamic()
    .bootstrapModule(AppModule)
    .catch(err => console.log(err));
```

### `src/polyfills.ts`

```ts
/**
 * This file includes polyfills needed by Angular and is loaded before the app.
 * You can add your own extra polyfills to this file.
 *
 * This file is divided into 2 sections:
 *   1. Browser polyfills. These are applied before loading ZoneJS and are sorted by browsers.
 *   2. Application imports. Files imported after ZoneJS that should be loaded before your main
 *      file.
 *
 * The current setup is for so-called "evergreen" browsers; the last versions of browsers that
 * automatically update themselves. This includes Safari >= 10, Chrome >= 55 (including Opera),
 * Edge >= 13 on the desktop, and iOS 10 and Chrome on mobile.
 *
 * Learn more in https://angular.io/docs/ts/latest/guide/browser-support.html
 */

/***************************************************************************************************
 * BROWSER POLYFILLS
 */

/** IE9, IE10 and IE11 requires all of the following polyfills. **/
// import 'core-js/es6/symbol';
// import 'core-js/es6/object';
// import 'core-js/es6/function';
// import 'core-js/es6/parse-int';
// import 'core-js/es6/parse-float';
// import 'core-js/es6/number';
// import 'core-js/es6/math';
// import 'core-js/es6/string';
// import 'core-js/es6/date';
// import 'core-js/es6/array';
// import 'core-js/es6/regexp';
// import 'core-js/es6/map';
// import 'core-js/es6/weak-map';
// import 'core-js/es6/set';

/** IE10 and IE11 requires the following for NgClass support on SVG elements */
// import 'classlist.js';  // Run `npm install classlist.js`.

/** IE10 and IE11 requires the following for the Reflect API. */
// import 'core-js/es6/reflect';

/** Evergreen browsers require these. **/
// Used for reflect-metadata in JIT. If you use AOT (and only Angular decorators), you can remove.
import "core-js/proposals/reflect-metadata";

/**
 * Required to support Web Animations `@angular/platform-browser/animations`.
 * Needed for: All but Chrome, Firefox and Opera. http://caniuse.com/#feat=web-animation
 **/
// import 'web-animations-js';  // Run `npm install web-animations-js`.

/***************************************************************************************************
 * Zone JS is required by default for Angular itself.
 */
import "zone.js/dist/zone"; // Included with Angular CLI.

/***************************************************************************************************
 * APPLICATION IMPORTS
 */
```

### `src/styles.css`

```css

```

### `src/typings.d.ts`

```ts
/* SystemJS module definition */
declare var module: NodeModule;
interface NodeModule {
    id: string;
}
```

### `.angular-cli.json`

```json
{
  "apps": [
    {
      "root": "src",
      "outDir": "dist",
      "assets": [ "assets", "favicon.ico" ],
      "index": "index.html",
      "main": "main.ts",
      "polyfills": "polyfills.ts",
      "prefix": "app",
      "styles": [ "styles.css" ],
      "scripts": [ ],
      "environmentSource": "environments/environment.ts",
      "environments": {
        "dev": "environments/environment.ts",
        "prod": "environments/environment.prod.ts"
      }
    }
  ]
}
```

### `_tsconfig.json`

```json
{
  "compileOnSave": false,
  "compilerOptions": {
    "baseUrl": "./",
    "outDir": "./dist/out-tsc",
    "sourceMap": true,
    "declaration": false,
    "allowSyntheticDefaultImports": true,
    "downlevelIteration": true,
    "experimentalDecorators": true,
    "moduleResolution": "node",
    "importHelpers": true,
    "resolveJsonModule": true,
    "target": "es2015",
    "module": "es2020",
    "lib": [
      "es2018",
      "dom"
    ]
  }
}
```

### `package.json`

```json
{
  "name": "surveyjs-angular",
  "scripts": {
    "ng": "ng",
    "start": "ng serve",
    "build": "ng build --prod",
    "test": "ng test",
    "lint": "ng lint",
    "e2e": "ng e2e"
  },
  "private": true,
  "dependencies": {
    "@angular/animations": "14.1.1",
    "@angular/cdk": "14.1.1",
    "@angular/common": "14.1.1",
    "@angular/compiler": "14.1.1",
    "@angular/core": "14.1.1",
    "@angular/forms": "14.1.1",
    "@angular/platform-browser": "14.1.1",
    "@angular/platform-browser-dynamic": "14.1.1",
    "@angular/router": "14.1.1",
    "core-js": "3.6.4",
    "rxjs": "6.5.4",
    "survey-core": "latest",
    "survey-angular-ui": "latest",
    "survey-pdf": "latest",
    "tslib": "1.13.0",
    "zone.js": "0.11.7"
  },
  "devDependencies": {
    "@angular/cli": "1.6.6",
    "@angular/compiler-cli": "^5.2.0",
    "@angular/language-service": "^5.2.0",
    "@types/core-js": "0.9.46",
    "@types/jasmine": "~2.8.3",
    "@types/jasminewd2": "~2.0.2",
    "@types/node": "~6.0.60",
    "codelyzer": "^4.0.1",
    "jasmine-core": "~2.8.0",
    "jasmine-spec-reporter": "~4.2.1",
    "karma": "~2.0.0",
    "karma-chrome-launcher": "~2.2.0",
    "karma-coverage-istanbul-reporter": "^1.2.1",
    "karma-jasmine": "~1.1.0",
    "karma-jasmine-html-reporter": "^0.2.2",
    "protractor": "~5.1.2",
    "ts-node": "~4.1.0",
    "tslint": "~5.9.1",
    "typescript": "3.9.7"
  },
  "keywords": [ "angular", "surveyjs" ],
  "description": "SurveyJS-Angular example project"
}
```

## Other Frameworks

- [React](https://surveyjs.io/pdf-generator/examples/template-product-usage-research-survey-template/reactjs.md)
- [Vue 3](https://surveyjs.io/pdf-generator/examples/template-product-usage-research-survey-template/vue3js.md)
- [jQuery](https://surveyjs.io/pdf-generator/examples/template-product-usage-research-survey-template/jquery.md)
- [Vanilla JS](https://surveyjs.io/pdf-generator/examples/template-product-usage-research-survey-template/vanillajs.md)


---
title: Product Usage Research Survey
product: PDF Generator
description: Get a printable product usage research survey in PDF. Create editable or prefilled product research questionnaires with SurveyJS PDF Generator.
framework: React
source: https://surveyjs.io/pdf-generator/examples/template-product-usage-research-survey-template/reactjs
index: https://surveyjs.io/pdf-generator/examples/overview.md
---

# Product Usage Research Survey (React)

## Files

### `public/index.html`

```html
<div style="display: flex;">
    <div id="surveyElement" style="flex: 1 1 0%; height: 100%; min-width: 0;"></div>
    <div id="pdf-preview" style="flex: 0.7 0.7 0%; display: none">
        <embed id="pdf-preview-frame" type="application/pdf" style="width:100%; height:100%;" />
    </div>
</div>
```

### `src/SurveyPdfComponent.jsx`

```js
import React from "react";
import { Model } from "survey-core";
import { SurveyPDF } from "survey-pdf";
import { Survey } from "survey-react-ui";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";

function createSurveyPdfModel (surveyModel) {
    const surveyPDF = new SurveyPDF(json);
    if (surveyModel) {
        surveyPDF.data = surveyModel.data;
        surveyPDF.locale = surveyModel.locale;
        
        
    }
    
    return surveyPDF;
}
function saveSurveyToPdf (filename, surveyModel) {
    const pdfDoc = createSurveyPdfModel(surveyModel);
    if (!pdfDoc) return;

    pdfDoc.save(filename);
}

const previewDiv = document.getElementById("pdf-preview");
const previewEmbed = document.getElementById("pdf-preview-frame");
let pdfBlobUrl;

function showPdfPreview(surveyModel) {
    if (!previewDiv || !previewEmbed) return;

    const pdfDoc = createSurveyPdfModel(surveyModel);
    if (!pdfDoc) return;

    pdfDoc.raw("blob").then((blob) => {
        if (pdfBlobUrl) {
            URL.revokeObjectURL(pdfBlobUrl);
        }
        pdfBlobUrl = URL.createObjectURL(blob);
        previewEmbed.setAttribute("src", pdfBlobUrl);
        previewDiv.style.display = "block";
    });
}

function previewPdf(surveyModel) {
    if (!previewDiv) return;

    if (previewDiv.style.display !== "none") {
        previewDiv.style.display = "none";
        return;
    }

    showPdfPreview(surveyModel);
}

function SurveyPdfComponent () {
    const survey = new Model(json);
    survey.showCompleteButton = false;
    survey.navigationButtonsLocation = "topBottom";
    survey.addNavigationItem({
        id: "survey_save_as_file",
        title: "Download PDF",
        action: () => {
            saveSurveyToPdf("surveyResult.pdf", survey);
        }
    });
    survey.addNavigationItem({
        id: "survey_pdf_preview",
        title: "Preview PDF",
        visible: window.navigator.pdfViewerEnabled,
        action: () => {
            previewPdf(survey);
        }
    });
    return (<Survey model={survey} />);
}

export default SurveyPdfComponent;
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import React from "react";
import { createRoot } from "react-dom/client";
import SurveyPdfComponent from "./SurveyPdfComponent";

const root = createRoot(document.getElementById("surveyElement"));
root.render(<SurveyPdfComponent />);
```

### `src/json.js`

```js
export const json = {
  "title": "Product Usage Research Survey",
  "questionsOnPageMode": "singlePage",
  "headerView": "advanced",
  "pages": [
    {
      "name": "participant-information",
      "title": "Section 1: Demographic Information",
      "elements": [
        {
          "type": "text",
          "name": "name",
          "title": "Full Name",
          "isRequired": true,
          "minWidth": "auto"
        },
        {
          "type": "text",
          "name": "dob",
          "startWithNewLine": false,
          "title": "Date of Birth",
          "inputType": "date",
          "minWidth": "auto"
        },
        {
          "type": "radiogroup",
          "name": "gender",
          "title": "Gender",
          "choices": [
            "Male",
            "Female",
            "Other"
          ],
          "startWithNewLine": false,
          "minWidth": "auto",
          "colCount": 2
        },
        {
          "type": "text",
          "name": "occupation",
          "title": "Current Occupation"
        },
        {
          "type": "text",
          "name": "location",
          "title": "City and Country of Residence",
          "startWithNewLine": false
        },
        {
          "type": "text",
          "name": "email",
          "title": "Email Address (optional)",
          "inputType": "email"
        },
        {
          "type": "text",
          "name": "phone-number",
          "startWithNewLine": false,
          "title": "Phone Number (optional)",
          "maskType": "pattern",
          "maskSettings": {
            "pattern": "+1(999)-999-99-99"
          }
        },
        {
          "type": "radiogroup",
          "name": "income",
          "title": "Approximate Household Income",
          "choices": [
            "Below $25,000",
            "$25,000 - $50,000",
            "$50,000 - $75,000",
            "$75,000 - $100,000",
            "Above $100,000"
          ],
          "colCount": 2
        },
        {
          "type": "radiogroup",
          "name": "education-level",
          "title": "Highest Level of Education Completed",
          "choices": [
            "High School",
            "Some College",
            "Bachelor Degree",
            "Master Degree",
            "Doctorate"
          ],
          "showOtherItem": true,
          "otherText": "Other",
          "colCount": 2
        },
        {
          "type": "radiogroup",
          "name": "marital-status",
          "title": "Marital Status",
          "choices": [
            "Single",
            "Married",
            "Divorced",
            "Widowed"
          ],
          "colCount": 2
        }
      ]
    },
    {
      "name": "product-information",
      "title": "Section 2: Purchase and Usage Details",
      "elements": [
        {
          "type": "checkbox",
          "name": "models",
          "title": "Select all sneaker models you have used",
          "isRequired": true,
          "choices": [
            "Nike Air Max Plus OG Voltage Purple",
            "Nike Dunk Low Brazil",
            "New Balance 1906R Lava",
            "Nike Air Max 95 Black",
            "Nike Air Max Dn Black",
            "Jordan Jumpman Jack Sail",
            "Air Jordan 1 Low OG Away"
          ],
          "showNoneItem": true,
          "colCount": 2
        },
        {
          "type": "paneldynamic",
          "name": "purchase-details",
          "title": "Provide details for each selected model",
          "panelCount": 3,
          "panelsState": "firstExpanded",
          "templateTitle": "Model {panelIndex}",
          "templateElements": [
            {
              "type": "text",
              "title": "Model Name"
            },
            {
              "name": "purchase-date",
              "title": "Date of Purchase",
              "type": "text",
              "inputType": "date",
              "startWithNewLine": false
            },
            {
              "name": "frequency",
              "title": "How often do you use this model?",
              "type": "radiogroup",
              "choices": [
                "Daily",
                "Several times a week",
                "Once a week",
                "Several times a month",
                "Once a month or less"
              ],
              "colCount": 2
            },
            {
              "name": "primary-activity",
              "title": "What is the primary use of this model?",
              "type": "radiogroup",
              "choices": [
                "Casual Wear",
                "Sports or Exercise",
                "Work or School",
                "Special Occasions",
                "Collecting"
              ],
              "colCount": 2,
              "startWithNewLine": false
            },
            {
              "type": "radiogroup",
              "name": "first-hear",
              "title": "How did you first learn about this model?",
              "choices": [
                "Social Media",
                "Friend or Family",
                "Online Advertisement",
                "In Store Display",
                "Review Website"
              ],
              "showOtherItem": true,
              "otherText": "Other"
            },
            {
              "type": "radiogroup",
              "name": "where-purchased",
              "startWithNewLine": false,
              "title": "Where did you purchase this model?",
              "choices": [
                "Online Retailer",
                "Official Website",
                "Physical Store",
                "Reseller"
              ],
              "showOtherItem": true,
              "otherText": "Other"
            },
            {
              "type": "boolean",
              "name": "remember-name",
              "title": "Do you remember the name of the store or seller?"
            },
            {
              "type": "text",
              "name": "specify-name",
              "startWithNewLine": false,
              "title": "If yes, enter the name of the store or seller"
            },
            {
              "type": "matrixdropdown",
              "name": "rating-matrix",
              "title": "Please rate the following aspects",
              "showHeader": false,
              "columns": [
                {
                  "name": "rating-scale",
                  "cellType": "rating",
                  "minRateDescription": "Very dissatisfied",
                  "maxRateDescription": "Very satisfied"
                }
              ],
              "rows": [
                {
                  "value": "comfort",
                  "text": "Comfort"
                },
                {
                  "value": "durability",
                  "text": "Durability"
                },
                {
                  "value": "design",
                  "text": "Design and Style"
                }
              ],
              "rowTitleWidth": "25%"
            }
          ]
        }
      ]
    },
    {
      "name": "usage-patterns",
      "title": "Section 3: Features and Preferences",
      "elements": [
        {
          "type": "paneldynamic",
          "name": "most-least-panel",
          "title": "Evaluate features for each selected model",
          "panelCount": 3,
          "panelsState": "firstExpanded",
          "templateTitle": "Model {panelIndex}",
          "templateElements": [
            {
              "type": "text",
              "title": "Model Name"
            },
            {
              "type": "ranking",
              "name": "like-most",
              "title": "Select and rank the features you like most",
              "choices": [
                "Comfort",
                "Style",
                "Brand Reputation",
                "Durability",
                "Limited Edition",
                "Versatility"
              ],
              "minSelectedChoices": 2,
              "selectToRankEnabled": true
            },
            {
              "type": "ranking",
              "name": "like-least",
              "title": "Select and rank the features you like least",
              "choices": [
                "Comfort",
                "Style",
                "Brand Reputation",
                "Durability",
                "Limited Edition",
                "Versatility"
              ],
              "minSelectedChoices": 2,
              "selectToRankEnabled": true
            },
            {
              "type": "boolean",
              "name": "issues",
              "title": "Have you experienced any issues with this model?",
              "showCommentArea": true,
              "commentText": "If yes, please describe the issue"
            },
            {
              "type": "radiogroup",
              "name": "recommend",
              "title": "Would you recommend this model to others?",
              "choices": [
                "Yes",
                "No",
                "Maybe"
              ],
              "colCount": 3
            },
            {
              "type": "radiogroup",
              "name": "purchase-same-brand",
              "title": "How likely are you to purchase from this brand again?",
              "choices": [
                "Very unlikely",
                "Unlikely",
                "Neutral",
                "Likely",
                "Very likely"
              ],
              "colCount": 2
            }
          ]
        }
      ]
    },
    {
      "name": "additional-feedback-section",
      "title": "Section 4: Additional Feedback",
      "elements": [
        {
          "type": "paneldynamic",
          "name": "additional-question",
          "title": "Additional Feedback (if applicable)",
          "panelCount": 3,
          "panelsState": "firstExpanded",
          "templateTitle": "Model {panelIndex}",
          "templateElements": [
            {
              "type": "boolean",
              "name": "support",
              "title": "Have you contacted customer support regarding this model?"
            },
            {
              "type": "rating",
              "name": "support-experience",
              "title": "If yes, how would you rate your experience?",
              "rateCount": 10,
              "rateMax": 10,
              "minRateDescription": "Very poor",
              "maxRateDescription": "Excellent"
            },
            {
              "type": "comment",
              "name": "improvements",
              "title": "What improvements would you suggest for this model?"
            },
            {
              "type": "comment",
              "name": "additional-comments",
              "title": "Please share any additional comments or feedback"
            }
          ]
        }
      ]
    }
  ]
};
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "react": "latest",
    "react-dom": "latest",
    "survey-core": "latest",
    "survey-react-ui": "latest",
    "survey-pdf": "latest"
  },
  "devDependencies": {
    "react-scripts": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/pdf-generator/examples/template-product-usage-research-survey-template/angular.md)
- [Vue 3](https://surveyjs.io/pdf-generator/examples/template-product-usage-research-survey-template/vue3js.md)
- [jQuery](https://surveyjs.io/pdf-generator/examples/template-product-usage-research-survey-template/jquery.md)
- [Vanilla JS](https://surveyjs.io/pdf-generator/examples/template-product-usage-research-survey-template/vanillajs.md)
